package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

public class Cleanup
{
   public static void main(String[] args)
   {
      System.out.println( "Total mem: " + Runtime.getRuntime().totalMemory() );
      System.out.println( "Free mem: " + Runtime.getRuntime().freeMemory() );

      byte  []buff = new byte[2];
      Point p1 = new Point( 12, 56 );
      Point p2 = new Point( 34, 78 );
      Line []lines = new Line[2000000];

      // allocating 1000 lines
      System.out.println( "Allocating 1000000 lines..." );
      for( int i = 0; i < 1999999; i++ )
         lines[i] = new Line( p1, p2 );

      System.out.println( "Total mem: " + Runtime.getRuntime().totalMemory() );
      System.out.println( "Free mem: " + Runtime.getRuntime().freeMemory() );

      System.out.println( "Press any key to start cleanup!" );
      try
      {
         System.in.read( buff );
      }
      catch( java.io.IOException e )
      {
         e.printStackTrace();
      }
      p1 = null;  // ok to do this, ref still in l1
      p2 = null;  // ok to do this, ref still in l1

      for( int i = 0; i < 1999999; i++ )
      {
         lines[i].destroy();
         lines[i] = null;
      }
      lines = null;

      System.out.println( "Total mem: " + Runtime.getRuntime().totalMemory() );
      System.out.println( "Free mem: " + Runtime.getRuntime().freeMemory() );

      System.out.println( "Press any key to force gc!" );
      try
      {
         System.in.read( buff );
      }
      catch( java.io.IOException e )
      {
         e.printStackTrace();
      }
      System.gc();
      System.out.println( "Total mem: " + Runtime.getRuntime().totalMemory() );
      System.out.println( "Free mem: " + Runtime.getRuntime().freeMemory() );
   }
}

/*class Line
{
   private  Point start = null;
   private  Point end   = null;

   public   Line( Point p1, Point p2 )
   {
      start = p1;
      end = p2;
   }

   public   void  destroy()
   {
      start = null;
      end = null;
   }
}

class Point
{
   private  int x = 0;;
   private  int y = 0;

   public   Point( int x, int y )
   {
      this.x = x;
      this.y = y;
   }

   public   void  finalize()
   {
      System.out.println( "Point finalizer!" );
   }
}*/