package s2s.javacourse;

import	java.io.*;

public class FileCopy
{
    private	String itsSource = null;
    private String itsTarget = null;
    
    public	FileCopy( String src, String tgt )
    {
        itsSource = src;
        itsTarget = tgt;
    }
    public	void	execute()
    {
        File input = new File( itsSource );
        
        if( !input.exists() )
        {
            System.out.println( input + " does not exist!" );
            return;
        }
        File output = new File( itsTarget );
        try
        {
            output.createNewFile();
            FileInputStream fis = new FileInputStream( input );
            FileOutputStream fos = new FileOutputStream( output );
            
            BufferedInputStream bis = new BufferedInputStream( fis );
            BufferedOutputStream bos = new BufferedOutputStream( fos );
            
            byte buffer[] = new byte[ 2048 ];
            
            int result = 2048;
            
            while( result != -1 )
            {
                int count = bis.available();
                if( count > 2048 )
                    count = 2048;
                if( count > 0 )
                    result = bis.read( buffer, 0, count );
                else
                    result = -1;
                
                if( result > 0 )
                {
                    bos.write( buffer, 0, result );
                }
            }
            
            bos.flush();
            bos.close();
            
        } catch (FileNotFoundException e)
        {
            e.printStackTrace();
        } catch (IOException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    static	public	void	main( String args[] )
    {
        if( args.length < 2 )
        {
            System.out.println( "run: java FileCopy <source> <target>" );
            System.exit( 0 );
        }
        
        FileCopy fc = new FileCopy( args[0], args[1] );
        fc.execute();
    }
}
