package s2s.javacourse;

//  GcLoops.java
import java.io.* ;
public class GCView
{

   public static void main(String args[] )
   {
      GCView obj = new GCView( 100000 );

      System.out.println ( "Start, free memory = " + Runtime.getRuntime().freeMemory() ) ;
      System.out.println ( "total memory = " + Runtime.getRuntime().totalMemory() ) ;

      obj.runTest(10) ;

      System.out.println( "Object creation time (millisecs) : " + obj.t1 );
      System.out.println( "Garbage collect time (millisecs) : " + obj.t2 );

      System.out.println ( "end, free memory = " + Runtime.getRuntime().freeMemory() ) ;
      System.out.println ( "total memory = " + Runtime.getRuntime().totalMemory() ) ;
      /*try
      {
         System.out.println( "Press any key to terminate!" );
         System.in.read();
      }
      catch(IOException e)
      {
      }*/
   }

   int count ; // number of objects to create
   int t1, t2 ;
   Object[] objects ;

   public GCView( int arn  )
   {
      count = arn ;
   }

   public void runTest(int rep )
   {
      long mem1, mem2, mem3, mem4 ;
      mem1 = mem2 = 0  ;
      long tstart, tend ;
      int i,j ;

      tstart = tend = 0;
      
      for( i = 0; i < rep ; i++ )
      {
          mem3 = Runtime.getRuntime().freeMemory();
          System.out.println("mem before gc:\t" + mem3 );
          mem1 += Runtime.getRuntime().freeMemory();
          tstart = System.currentTimeMillis();
          
          objects = new Object[ count ] ;
        
          for( j = 0; j < count ; j++ )
          {
              objects[j] = new StringBuffer( 200 ) ;
          }
          tend = System.currentTimeMillis();
          mem2 += Runtime.getRuntime().freeMemory();
          
          mem4 = Runtime.getRuntime().freeMemory();
          System.out.println("mem after gc:\t" + mem4 );
          
          t1 += (int)(tend - tstart);
          tstart = System.currentTimeMillis();
          
          // comment out this line to see how the figures change...
          //objects = null ;

          // comment out this line to see how the figures change...
          System.gc();
          
          Thread.yield();
          tend = System.currentTimeMillis();
          t2 += (int)(tend - tstart);
      }
      System.out.println("ave total mem before gc\t=\t" + mem1/rep );
      System.out.println("ave free mem after gc\t=\t" + mem2/rep );
   }
}
