package s2s.javacourse;

import java.io.*;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

public class GarbageCollector
{
   public static void main(String[] args)
   {
      Point p1 = new Point( 12, 56 );
      Point p2 = new Point( 34, 78 );
      Line l1 = new Line( p1, p2 );

      System.out.println( "Press any key to continue!" );
      p1 = null;  // ok to do this, ref still in l1
      p2 = null;  // ok to do this, ref still in l1
      l1.destroy();
      l1 = null;

      try
      {
          InputStreamReader isr = new InputStreamReader( System.in );
          LineNumberReader lcr = new LineNumberReader( isr );
          
          lcr.readLine();
      }
      catch( java.io.IOException e )
      {
         e.printStackTrace();
      }
   }
}

class Line
{
   private  Point start = null;
   private  Point end   = null;

   public   Line( Point p1, Point p2 )
   {
      start = p1;
      end = p2;
   }

   public   void  destroy()
   {
      start = null;
      end = null;
   }

   public   void  finalize()
   {
      System.out.println( "Line finalizer!" );
   }
}

class Point
{
   private  int x = 0;;
   private  int y = 0;

   public   Point( int x, int y )
   {
      this.x = x;
      this.y = y;
   }

   public   void  finalize()
   {
      System.out.println( "Point finalizer!" );
   }
}