package s2s.javacourse;

/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.awt.Frame;
import   java.awt.MenuBar;
import   java.awt.Menu;
import   java.awt.MenuItem;
import   java.awt.Dimension;
import   java.awt.event.ActionListener;
import   java.awt.event.ActionEvent;
import   java.net.InetAddress;
import   java.net.UnknownHostException;

public class InetAddressByName extends Frame
{
   private  static   String   itsHostName = "";

   public InetAddressByName()
   {
      super( "Lookup info via InetAddress" );
   }

   public   Dimension   getPreferredSize()
   {
      return   new Dimension( 400, 150 );
   }

   private  class ExitMenuHandler   implements  ActionListener
   {
      public   void  actionPerformed( ActionEvent e )
      {
         System.exit( 0 );
      }
   }

   private  class LookupByNameHandler   implements  ActionListener
   {
      public   void  actionPerformed( ActionEvent ev )
      {
         try
         {
            InetAddress address = InetAddress.getByName( itsHostName );
            System.out.println( address );
         }
         catch( UnknownHostException e )
         {
            System.out.println( e );
         }
      }
   };

   private  class LookupAllByNameHandler   implements  ActionListener
   {
      public   void  actionPerformed( ActionEvent ev )
      {
         try
         {
            InetAddress[] addresses = InetAddress.getAllByName( itsHostName );
            for( int i = 0; i < addresses.length; i++ )
               System.out.println( addresses[i] );
         }
         catch( UnknownHostException e )
         {
            System.out.println( e );
         }
      }
   };

   private  class LookupLocalHostHandler   implements  ActionListener
   {
      public   void  actionPerformed( ActionEvent ev )
      {
         try
         {
            InetAddress address = InetAddress.getLocalHost();
               System.out.println( address );
         }
         catch( UnknownHostException e )
         {
            System.out.println( e );
         }
      }
   };

   private  void  initWindow()
   {
      MenuBar mb = new MenuBar();
      Menu fileMenu = new Menu( "File" );

      // add items to menus
      MenuItem lookupItem = new MenuItem( "Lookup" );
      MenuItem lookupAllItem = new MenuItem( "Lookup All..." );
      MenuItem localHostItem = new MenuItem( "Local Host" );
      MenuItem exitItem = new MenuItem( "Exit" );
      fileMenu.add( lookupItem );
      fileMenu.add( lookupAllItem );
      fileMenu.add( localHostItem );
      fileMenu.add( exitItem );
      mb.add( fileMenu );

      // set the menubar for the frame
      setMenuBar( mb );

      // now setup handlers
      ActionListener menuItemAction = new ExitMenuHandler();
      exitItem.addActionListener( menuItemAction );

      ActionListener lookupItemAction = new LookupByNameHandler();
      lookupItem.addActionListener( lookupItemAction );

      ActionListener lookupAllItemAction = new LookupAllByNameHandler();
      lookupAllItem.addActionListener( lookupAllItemAction );

      ActionListener localHostItemAction = new LookupLocalHostHandler();
      localHostItem.addActionListener( localHostItemAction );
   }

   public static void main(String[] args)
   {
      if( args.length < 1 )
      {
         System.out.println( "InetAddressByName <hostName>" );
         System.exit( 0 );
      }
      itsHostName = args[0];
      InetAddressByName inetAddressByName1 = new InetAddressByName();
      inetAddressByName1.initWindow();
      inetAddressByName1.pack();
      inetAddressByName1.setVisible( true );
   }
}
