package s2s.javacourse;

import javax.swing.JFrame;

/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   javax.swing.*;
import   javax.swing.event.*;
import   java.awt.*;
import   java.awt.event.*;

public class ScrollableComplexListFrame extends JFrame
{
   private  JList list = null;
   private  boolean toggle = false;
   private  String[] listData = null;

   class MyListSelectionListener implements ListSelectionListener
   {
      public   void  valueChanged( ListSelectionEvent e )
      {
         String value;

         // Ignore these two, adjusting means redrawing usually
         if( (e.getValueIsAdjusting()==false) || (e.getFirstIndex()== -1) )
            return;

         // This is how the data...
         JList theList = (JList)e.getSource();
         MyListModel myModel = (MyListModel)theList.getModel();

         value = (String)myModel.getElementAt( theList.getSelectedIndex() );

         System.out.println( value );
      }
   }

   class MyListModel extends DefaultListModel
   {
      int mySize = 0;
      String[] listData1;

      public   MyListModel( String data1[] )
      {
         listData1 = data1;
      }

      public   String[] getData1()
      {
         return listData1;
      }

      public   int getSize()
      {
         return listData1.length;
      }

      public   Object getElementAt(int index)
      {
         return listData1[ index ];
      }
   }

   public ScrollableComplexListFrame()
   {
      super( "JScroll List Example" );
   }

   public   void  initWindow()
   {
      setSize( 300, 200 );
      String data[] = {"Item1", "Item2", "Item3", "Item4", "Item5",
                       "Item6", "Item7", "Item8", "Item9", "Item10",
                       "Item11", "Item12", "Item13", "Item14", "Item15",
                       "Item16", "Item17", "Item18", "Item19", "Item20",
                       "Item21", "Item22", "Item23", "Item24", "Item25" };

      list = new JList();

      list.setModel( new MyListModel( data ) );

      list.addListSelectionListener( new MyListSelectionListener() );

      JScrollPane scroller = new JScrollPane();
      scroller.setViewportView( list );

      getContentPane().add( scroller, BorderLayout.NORTH );

      JButton exitBtn = new JButton( "Exit Application" );

      exitBtn.addActionListener( new ActionListener()
         {
            public   void  actionPerformed( ActionEvent e )
            {
               System.exit( 0 );
            }
         } );


      JPanel btnsPanel = new JPanel();
      btnsPanel.add( exitBtn, BorderLayout.SOUTH );
      getContentPane().add( btnsPanel );
   }

   public static void main(String[] args)
   {
      ScrollableComplexListFrame scrollableFrame1 = new ScrollableComplexListFrame();

      scrollableFrame1.initWindow();

      scrollableFrame1.pack();
      scrollableFrame1.setVisible( true );
   }
}
