package stream2stream.chat02;

/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.awt.Dimension;
import   javax.swing.*;
import   java.awt.event.*;
import   java.awt.Container;
import   java.awt.BorderLayout;

import  stream2stream.chatComms.stage1.*;

public class ChatWnd extends JFrame
{
   static   final String   hostName = "localhost";
   static   final int      portNo = 8091;

   private  ChatServerHandler itsServerHandler = null;

   private  JMenuBar itsMenuBar = new JMenuBar();
   private  JMenu itsFileMenu = new JMenu( "File" );
   private  JMenuItem itsExitItem = new JMenuItem( "Exit" );
   private  JMenuItem itsStartServerItem = new JMenuItem( "Start Server" );
   private  JMenuItem itsStopServerItem = new JMenuItem( "Stop Server" );
   private  JSeparator itsSeparatorItem = new JSeparator();

   public ChatWnd( String whois )
   {
      super( whois + "/Chat" );
   }

   public   Dimension   getPreferredSize()
   {
      return   new Dimension( 300, 300 );
   }

   public   void  initWindow()
   {
      Container itsMainPanel = getContentPane();

      itsFileMenu.add( itsStartServerItem );
      itsFileMenu.add( itsStopServerItem );
      itsFileMenu.add( itsSeparatorItem );
      itsFileMenu.add( itsExitItem );

      itsMenuBar.add( itsFileMenu );
      setJMenuBar( itsMenuBar );

      JPanel itsDataPanel = new JPanel();
      JTextArea textArea = new JTextArea("Some data");
      itsDataPanel.add( textArea );

      JPanel itsButtonPanel = new JPanel();
      itsButtonPanel.add( new JButton( "Send" ) );

      itsMainPanel.add( itsDataPanel, BorderLayout.CENTER );
      itsMainPanel.add( itsButtonPanel, BorderLayout.SOUTH );

      setupEventHandlers();

      pack();
      //++setVisible( true );
   }

   private  void  setupEventHandlers()
   {
      this.addWindowListener( new WindowAdapter()
         {
            public   void  windowClosing( WindowEvent ev )
            {
                if( itsServerHandler != null )
                {
                    itsServerHandler.closeServerConnection();
                }
               dispose();
               System.exit( 0 );
            }
         } );

      itsExitItem.addActionListener( new ActionListener()
         {
            public   void  actionPerformed( ActionEvent ev )
            {
                if( itsServerHandler != null )
                {
                    itsServerHandler.closeServerConnection();
                }
               dispose();
               System.exit( 0 );
            }
         } );
      itsStartServerItem.addActionListener( new ActionListener()
         {
            public   void  actionPerformed( ActionEvent ev )
            {
                if( itsServerHandler == null )
                {
                    itsServerHandler = new ChatServerHandler( hostName, portNo );
                    itsServerHandler.start();
                }
            }
         } );
      itsStopServerItem.addActionListener( new ActionListener()
         {
            public   void  actionPerformed( ActionEvent ev )
            {
                if( itsServerHandler != null )
                {
                    itsServerHandler.stopServer();
                    itsServerHandler = null;
                }
            }
         } );
   }
}