/*
 * ChatServer.java
 *
 * Created on 26 September 2003, 09:05
 */

/*
 *  This basic server will wait for connections and spawn a new ChatClientHandler
 *  for each new client connection.  It will not remember the connections so it
 *  cannot close them all if it should be closed...
 */

package stream2stream.chatComms.stage2;

import  java.lang.Thread;
import  java.lang.Runnable;
import  java.net.*;

/**
 *
 * @author  Administrator
 */
public class ChatServerHandler implements  Runnable
{
	private int itsPort = 0;
	private String itsHost = null;
	
	private boolean is_Active = true;
	
    
    /** Creates a new instance of ChatServer */
    public ChatServerHandler(String host, int port)
    {
		itsHost = host;
		itsPort = port;
    }
    
	public void start() 
    {
		new Thread(this).start();
	}
	
	public void run() 
    {    
        setActiveState( true );
        
		try 
        {
            ServerSocket server = new ServerSocket( itsPort );
            
			while (getActiveState()) 
            {
				Socket client = server.accept();
				System.out.println("Connection accepted from " + client.getLocalAddress());
                
                Thread newThread = new Thread( new ChatClientHandler( client ) );
                
                newThread.start();
			}
            
            server.close();
		}
		catch (Exception e) 
        {
			e.printStackTrace();
		}
	}
	
	public void setActiveState( boolean state ) 
    {
		is_Active = state;
	}
    
    public  boolean getActiveState()
    {
        return  is_Active;
    }
}
